# Can Large Language Models Replace Human in Speech Analysis?


This repository encompasses the complete codebase developed for addressing the key research question of our thesis, "Can Large Language Models Replace Humans in Speech Analysis?" This comprehensive collection of code and resources forms an integral part of the Master's Thesis for the Master in Fundamentals and Principles of Data Science, supervised by Santi Seguí and elaborated by Pol Gareta Casas.

## Notebooks

The notebooks within this repository are organized into three distinct folders for streamlined access and clarity:

### `Data_Processing`
This folder contains notebooks dedicated to various aspects of data handling. It includes:
- **Audio Files Data Exploration:** Exploration of audio file data, providing insights into their characteristics and specifics.
[Data Exploration](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Data_Processing/data_exploration.ipynb)
- **Template Data Exploration:** Exploration of template data, essential for understanding the underlying structure and content.
[Data Evalaution](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Data_Processing/evaluation_template.ipynb)
- **Audio Preprocessing:** Audio preprocessing steps to adapt the audio files for the audio-to-text model.
[Audio Preprocessing](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Data_Processing/data_preprocessing.ipynb)
- **Fine-Tune Data Generation:** Preparing data specifically for fine-tuning the model.
[Fine-tune Data](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Data_Processing/data_finetunning.ipynb)


### `Model_Evaluation`
This folder encompasses notebooks that are instrumental in evaluating model performance:
- Notebooks within this section are used to assess and analyze the efficacy of different models.
[Evaluation Baseline Model](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Model_Evaluation/evaluation_baseline.ipynb)
[Evaluation Improvements Models](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Model_Evaluation/evaluation_improvements.ipynb)

### `Models`
This folder is the repository for the models themselves:
- The models evaluated in the `Model_Evaluation` folder are stored here.

[Baseline Model](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Models/baseline_model.ipynb)
[Improvements Models](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Models/model_eng_and_improvemtns.ipynb)
[Fine-Tuned Model](https://github.com/garetapo/Can-LLMs-Replace-Human-in-Speech-Analysis/blob/main/Models/model_finetune.ipynb)
